package com.monetra.unitermdemo;

import android.app.AlertDialog;
import android.app.Dialog;
import android.app.DialogFragment;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;

/**
 * Created by gweston on 10/12/16.
 */
public class QuickChipDialogFragment extends DialogFragment {
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        final MainActivity activity = ((MainActivity) getActivity());
        final View saleParamsView = View.inflate(activity, R.layout.dialog_sale, null);
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setMessage("Please enter an amount.")
                .setView(saleParamsView)
                .setPositiveButton("Finish QuickChip", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        String amount = ((EditText) saleParamsView.findViewById(R.id.amount)).getText().toString();
                        activity.finishQuickChip(amount);
                    }
                })
                .setNegativeButton("Cancel QuickChip", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        activity.cancelTransaction();
                    }
                })
                .setNeutralButton("Close", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        dialog.dismiss();
                    }
                });
        return builder.create();
    }

    public static QuickChipDialogFragment newInstance() {
        QuickChipDialogFragment f = new QuickChipDialogFragment();
        return f;
    }
}
