package com.monetra.unitermdemo;

import android.app.Activity;
import android.app.FragmentManager;
import android.os.Bundle;

import com.monetra.csv.CsvParser;
import com.monetra.uniterm.sdk.UnitermServiceHelper;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * Created by gweston on 10/3/16.
 */

public class SettingsActivity extends Activity implements UnitermServiceHelper.UnitermServiceHelperCallbacks {

    private static final String UNITERMSERVICEHELPER_FRAGMENT = "UnitermServiceHelper_fragment";
    // The SDK object.
    private UnitermServiceHelper mUnitermServiceHelper;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_settings);
        FragmentManager fm = getFragmentManager();
        mUnitermServiceHelper = (UnitermServiceHelper) fm.findFragmentByTag(UNITERMSERVICEHELPER_FRAGMENT);
        if (mUnitermServiceHelper == null) {
            mUnitermServiceHelper = new UnitermServiceHelper();
            fm.beginTransaction().add(mUnitermServiceHelper, UNITERMSERVICEHELPER_FRAGMENT).commit();
            fm.executePendingTransactions();
        }
        // Populate the device information.
        mUnitermServiceHelper.DoBluetoothlist();
        mUnitermServiceHelper.DoDevicetypes();
    }

    public void BluetoothlistResponse(String csv) {

        // Did we get anything back?
        if (csv == null)
            return;

        // Parse the CSV.
        CsvParser csvp = new CsvParser(csv);

        // Pull out the info we need.
        int rows = csvp.numRows();
        ArrayList keys = new ArrayList(rows);
        ArrayList values = new ArrayList(rows);
        for (int row = 0; row < rows; row++) {
            String name = csvp.getCell(row, "name");
            String mac = csvp.getCell(row, "mac");
            String uid = csvp.getCell(row, "uid");

            if (name == null || name.isEmpty() || mac == null || mac.isEmpty()) {
                continue;
            }

            String val = "BT:" + mac;
            if (uid != null && !uid.isEmpty()) {
                val += "," + uid;
            }

            keys.add(name);
            values.add(val);
        }

        SettingsFragment settingsFragment = (SettingsFragment) getFragmentManager().findFragmentById(R.id.settings_content);
        settingsFragment.populateDeviceList(keys, values);

    }

    public void DevicetypesResponse(String csv) {

        // Did we get anything back?
        if (csv == null)
            return;

        // Parse the CSV.
        CsvParser csvp = new CsvParser(csv);

        // Pull out the info we need.
        int rows = csvp.numRows();
        ArrayList keys = new ArrayList(rows);
        ArrayList values = new ArrayList(rows);
        for (int row = 0; row < rows; row++) {
            String type  = csvp.getCell(row, "devicetype");
            String model = csvp.getCell(row, "model");
            String connectivity = csvp.getCell(row, "connectivity");

            if (type == null || type.isEmpty()  ||
                    model == null || model.isEmpty() ||
                    connectivity == null || connectivity.isEmpty() ||
                    !connectivity.toLowerCase().contains("bluetooth"))
            {
                continue;
            }

            keys.add(model);
            values.add(type);
        }

        SettingsFragment settingsFragment = (SettingsFragment) getFragmentManager().findFragmentById(R.id.settings_content);
        settingsFragment.populateDeviceTypes(keys, values);

    }

    public void TxnrequestResponse(HashMap<String, String> kvs) {}
    public void TxnstartResponse(HashMap<String, String> kvs) {}
    public void TxnfinishResponse(HashMap<String, String> kvs) {}
    public void TxnrequestStatusResponse(HashMap<String, String> kvs) {}
    public void TxnrequestCancelResponse(HashMap<String, String> kvs) {}
    public void DeviceloadResponse(HashMap<String, String> kvs) {}
    public void PassthroughResponse(HashMap<String, String> kvs) {}
    public void VersionResponse(HashMap<String, String> kvs) {}
    public void RawKVS(HashMap<String, String> kvs) {}
}
